#!/usr/bin/env ruby -KU

###################################
#
# R daemon
#
# reads on r_in
# writes R's output to r_out
#
# written by Hans-Jörg Bibiko - bibiko@eva.mpg.de
###################################

require 'pty'

$rdout = File.join(ENV['HOME'], "IRBdaemon")

$fhist = File.open($rdout + '/history/Rhistory.txt', "a")

if ENV['TM_IRBdaemonRAMDRIVE'] == "1"
	cmd = "irb > /tmp/TMIRBramdisk1/r_out"
else
	cmd = "irb > " + $rdout + "/r_out"
end

PTY.spawn(cmd) { |r,w,pid|
	r.sync = FALSE
	# write r to the nirvana
	Thread.new {
		r.read
	}
	
	fin = File.open($rdout + '/r_in', "r+")
	while TRUE
		#wait for a new task and send it to R
		task = fin.gets
		$fhist.puts task if !task.match('^@\|') && !task.empty? && task != "\n"
		task.gsub!(/^@\|/, '')
		$fhist.flush
		w.puts task
	end
}